<template>
  <v-container>
    <v-row>
      <v-col>
        <h1 class="text-h3 text-center">Please enjoy our jokes</h1>
      </v-col>
    </v-row>

    <v-row v-if="getJokes.length === 0">
      <v-col class="text-center">
        <p class="text-body-1 font-italic">There are no jokes yet!<br/>Hit the button below to start your
          entertainment...</p>
      </v-col>
    </v-row>

    <v-row>
      <v-col>
        <joke-item v-for="(joke, index) in getJokes"
                   :key="index"
                   :joke="joke"
                   :joke-index="index"
        />
      </v-col>
    </v-row>

    <v-row>
      <v-col cols="12">
        <chuck-norris-toggler :initial-state="excludeChuckNorris"
                              @chuck-norris-toggle="toggleChuckNorrisFilter"
        />
      </v-col>
      <v-col cols="12"
             style="text-align: center"
      >
        <v-btn color="primary"
               outlined
               x-large
               @click="loadNewJoke(excludeChuckNorris)"
               :loading="isLoading('loadingJoke')"
        >
          Load new Joke
        </v-btn>
      </v-col>
    </v-row>

  </v-container>
</template>

<script lang="ts">
import {Component, Vue} from "vue-property-decorator";
import {mapGetters} from "vuex";
import JokeItem from "@/components/JokeItem.vue";
import ChuckNorrisToggler from "@/components/ChuckNorrisToggler.vue";

@Component({
  components: {ChuckNorrisToggler, JokeItem},
  computed: {
    ...mapGetters({
      isLoading: 'isLoading',
    }),
    ...mapGetters('joke', {
      getJokes: 'getJokes',
    }),
  },
})
export default class Jokes extends Vue {
  excludeChuckNorris = false;

  loadNewJoke() {
    this.$store.dispatch('joke/loadJoke', this.excludeChuckNorris);
  }

  toggleChuckNorrisFilter(excludeChuckNorris: boolean) {
    this.excludeChuckNorris = excludeChuckNorris;
  }
}

</script>